/**
 * Created by wangxiaoying on 2019/04/15
 * 字符串验证模块，通过返回true，未通过返回false
 */

/**
 * 未知用途
 */
export function isExternal(path) {
  return /^(https?:|mailto:|tel:)/.test(path)
}
/* 合法uri*/
export function validateURL(textval) {
  const urlregex = /^(https?|ftp):\/\/([a-zA-Z0-9.-]+(:[a-zA-Z0-9.&%$-]+)*@)*((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]?)(\.(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9]?[0-9])){3}|([a-zA-Z0-9-]+\.)*[a-zA-Z0-9-]+\.(com|edu|gov|int|mil|net|org|biz|arpa|info|name|pro|aero|coop|museum|[a-zA-Z]{2}))(:[0-9]+)*(\/($|[a-zA-Z0-9.,?'\\+&%$#=~_-]+))*$/
  return urlregex.test(textval)
}

/* 合法uri*/
export function validateNull(textval) {
  return !!textval
}

/* 验证小写字母*/
export function validateLowerCase(str) {
  const reg = /^[a-z]+$/
  return reg.test(str)
}

/* 验证大写字母*/
export function validateUpperCase(str) {
  const reg = /^[A-Z]+$/
  return reg.test(str)
}

/* 验证大小写字母*/
export function validateAlphabets(str) {
  const reg = /^[A-Za-z]+$/
  return reg.test(str)
}

/**
 * 验证邮箱
 * @param email
 * @returns {boolean}
 */
export function validateEmail(email) {
  const re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
  return re.test(email)
}

/**
 * 验证手机号
 * @param phone
 * @returns {boolean}
 */
export function validatePhone(phone) {
  const re = /^1([38][0-9]|4[579]|5[0-3,5-9]|6[6]|7[0135678]|9[89])\d{8}$/
  return re.test(phone)
}

/**
 * 验证一定范围内的非负整数
 */
export function validateIntPlus(value, min, max) {
  const re = /^\d+$/
  if (re.test(value)) {
    const data = parseInt(value)
    if (data > max || data < min) {
      return false
    }
  } else {
    return true
  }
}
/**
 * 验证一定范围内的非负小数
 */
export function validateFloatPlus(value, min, max) {
  const re = /^\d+(\.\d+)?$/
  if (re.test(value)) {
    const data = parseFloat(value)
    if (data > max || data < min) {
      return false
    } else {
      return true
    }
  } else {
    return false
  }
}

// 身份证号码校验validator
export const validateIDCard = (rule, value, callback) => {
  if (value !== '') {
    if ((/^[1-9]\d{5}(18|19|20|(3\d))\d{2}((0[1-9])|(1[0-2]))(([0-2][1-9])|10|20|30|31)\d{3}[0-9Xx]$/).test(value) === false) {
      callback(new Error('请输入合法的身份证号'))
    } else {
      callback()
    }
  } else {
    callback(new Error('身份证号不能为空'))
  }
}

// 手机号验证validator
export const phoneValidator = (rule, value, callback) => {
  const reg = /^1([38][0-9]|4[579]|5[0-3,5-9]|6[6]|7[0135678]|9[89])\d{8}$/
  if (value !== '') {
    if (reg.test(value) === false) {
      callback(new Error('请输入正确的手机号'))
    } else {
      callback()
    }
  } else {
    callback(new Error('手机号不能为空'))
  }
}

// 体温校验validator
export const temValidator = (rule, value, callback) => {
  const reg = /^\d+(\.\d+)?$/
  if (value !== '') {
    if (reg.test(value) === false) {
      callback(new Error('请输入数字'))
    } else {
      const data = parseFloat(value)
      if (data > 37.3 || data < 35) {
        callback(new Error('请检查体温'))
      } else {
        callback()
      }
    }
  } else {
    callback(new Error('体温不能为空'))
  }
}

// 车牌号校验validator
export const plateValidator = (rule, value, callback) => {
  const reg = /^[京津晋冀蒙辽吉黑沪苏浙皖闽赣鲁豫鄂湘粤桂琼渝川贵云藏陕甘青宁新][ABCDEFGHJKLMNPQRSTUVWXY][\dABCDEFGHJKLNMxPQRSTUVWXYZ]{5}$/
  const regNew = /^[京津晋冀蒙辽吉黑沪苏浙皖闽赣鲁豫鄂湘粤桂琼渝川贵云藏陕甘青宁新][ABCDEFGHJKLMNPQRSTUVWXY][1-9DF][1-9ABCDEFGHJKLMNPQRSTUVWXYZ]\d{3}[1-9DF]$/
  if (value !== '') {
    if (reg.test(value) === false && regNew.test(value) === false) {
      callback(new Error('请输入正确的车牌号'))
    } else {
      callback()
    }
  } else {
    callback(new Error('车牌号不能为空'))
  }
}
